package org.act.manage;
import java.util.*;
import org.act.manage.util.*;
import org.w3c.dom.*;

public class RBACManager
{
    	private HashMap mUserServerMap;    private HashMap mUserRightsMap;
        private boolean mIsTop;
        ArrayList mTreeBuilders;
    private String mserver="";
    private String mUserName;
    private String mServerType="";
    
    public RBACManager()
    {
        mUserRightsMap = new HashMap();
        mTreeBuilders = new ArrayList();
        mUserServerMap= new HashMap();
    }
    
    public String login(String UserName)
    {
        try
        {
            this.mUserName=UserName;
        	Document doc = XMLConfigUtil.loadDocumentFromFile(Utils.
                mUserConfigFile);
                        Vector userEles = XMLConfigUtil.getElement(doc, null, "user", null);
            if (userEles == null)
                throw new Exception("No Users");
            Element userEle = null;
            for (int i = 0; i < userEles.size(); i++)
            {
                userEle = (Element)userEles.get(i);
                if (UserName.equals(XMLConfigUtil.getTextByPath(doc, userEle
                    , "username", null, null)))
                    break;
            }
                        String top = XMLConfigUtil.getTextByPath(doc, userEle
                , "purview/top", null, null);
            if (top.equals("true"))
            {
                mIsTop = true;
                initTreeBuilders(UserName);
                return "";
            }
            
                                    String type="";
                        Vector runtimeEles = XMLConfigUtil.getElement(doc, userEle, "purview/WSRumtime", null);
            Element runtimeEle = null;
            
            for (int i = 0; i < runtimeEles.size(); i++)
            {
            	
            	runtimeEle = (Element)runtimeEles.get(i);
            	type = XMLConfigUtil.getTextByPath(doc, runtimeEle
	                , "pv", null, null);
            	if (type != null && !type.equals("")) {
					HashMap map = new HashMap();
					AddActionByPath("Basic", map);
					AddPlatformAction("WSRuntime", type, map);
					mserver = XMLConfigUtil.getTextByPath(doc, runtimeEle,
							"name", null, null);
					mUserServerMap.put(mserver, map);
					mUserRightsMap.clear();
					mServerType = "WSRuntime";
				}
			}
            
                                    
            Vector wfEles = XMLConfigUtil.getElement(doc, userEle, "purview/Workflow", null);
            Element wf = null;
            for (int i = 0; i < wfEles.size(); i++)
            {
            	
            	wf = (Element) wfEles.get(i);
				type = XMLConfigUtil.getTextByPath(doc, wf, "pv", null, null);
				if (type != null && !type.equals("")) {
					HashMap map = new HashMap();
					AddActionByPath("Basic", map);
					AddPlatformAction("Workflow", type, map);
					mserver = XMLConfigUtil.getTextByPath(doc, wf, "name",
							null, null);
					mUserServerMap.put(mserver, map);
					mUserRightsMap.clear();
					mServerType = "WorkflowEngine";
				}
            }
            initTreeBuilders(mserver);
            mIsTop = false;
                    }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
        return mserver;
    }
        public ArrayList getTreeBuilders()
    {
        return mTreeBuilders;
    }
    
    public ArrayList changeTreeBuilders(String server)
    {
    	initTreeBuilders(server);
    	return mTreeBuilders;
    }
        private void initTreeBuilders(String server)
    {
        try
        {
        	mTreeBuilders.clear();
        	Document doc = XMLConfigUtil.loadDocumentFromFile(Utils.
                mUserConfigFile);
                        Vector userEles = XMLConfigUtil.getElement(doc, null, "user", null);
            if (userEles == null)
                throw new Exception("No Users");
            Element userEle = null;
            for (int i = 0; i < userEles.size(); i++)
            {
                userEle = (Element)userEles.get(i);
                if (mUserName.equals(XMLConfigUtil.getTextByPath(doc, userEle
                    , "username", null, null)))
                    break;
            }
            Document treeDoc = XMLConfigUtil.loadDocumentFromFile(Utils.
                mACTAdminConfigFile);
            
            
                        Vector runtimeEles = XMLConfigUtil.getElement(doc, userEle, "purview/WSRumtime", null);
            Element runtimeEle = null;
            for (int i = 0; i < runtimeEles.size(); i++)
            {
            	runtimeEle = (Element)runtimeEles.get(i);
            	if (server.equals(XMLConfigUtil.getTextByPath(doc, runtimeEle,
						"name", null, null))) {
            		String type = XMLConfigUtil.getTextByPath(doc, runtimeEle,
							"pv", null, null);
					if ((type != null && !type.equals("")))
					{
						mTreeBuilders.add(XMLConfigUtil.getTextByPath(treeDoc,
								null, "TreeBuilders/XLinker", null, "Class"));
						mServerType="WSRuntime";
					}
					break;
				}
            }
                        Vector wfEles = XMLConfigUtil.getElement(doc, userEle, "purview/Workflow", null);
            Element wf = null;
            for (int i = 0; i < wfEles.size(); i++)
            {
            	wf = (Element)wfEles.get(i);
            	if (server.equals(XMLConfigUtil.getTextByPath(doc, wf
		                , "name", null, null)))
            	{
            		String type = XMLConfigUtil.getTextByPath(doc, wf
        	                , "pv", null, null);
                    if ((type != null && !type.equals("")))
                    {
                    	mTreeBuilders.add(XMLConfigUtil.getTextByPath(treeDoc, null
                               , "TreeBuilders/Workflow", null, "Class"));
                    	mServerType="WorkflowEngine";
                    }
                    
            		break;
            	}
	        }
            
                        
                        if (mIsTop)
                mTreeBuilders.add(XMLConfigUtil.getTextByPath(treeDoc, null
                    , "TreeBuilders/User", null, "Class"));
                        mTreeBuilders.add(XMLConfigUtil.getTextByPath(treeDoc, null
                , "TreeBuilders/person", null, "Class"));
            mTreeBuilders.add(XMLConfigUtil.getTextByPath(treeDoc, null
                    , "TreeBuilders/Logout", null, "Class"));
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
        private HashMap AddActionByPath(String path,HashMap map)
    {
        try
        {
            Document doc = XMLConfigUtil.loadDocumentFromFile(Utils.
                mRBACConfigFile);
                        Vector eles = XMLConfigUtil.getElement(doc, null
                , path + "/Action", null);
            if (eles == null)return null;
            String action = null;
            Element basic = null;
            for (int i = 0; i < eles.size(); i++)
            {
                basic = (Element)eles.get(i);
                action = XMLUtils.getTextValueOfElement(basic);
                map.put(action, new Boolean(true));
            }
        }
        catch (Exception ex)
        {
        }
        return map;
    }
            private void AddPlatformAction(String Platform, String Type,HashMap map)
    {
        if (Type == null || Type.equals(""))
            return;
        if (Type.indexOf("view") != -1)
            AddActionByPath(Platform + "/View",map);
        if (Type.indexOf("modify") != -1)
            AddActionByPath(Platform + "/Modify",map);
        if (Type.indexOf("delete") != -1)
            AddActionByPath(Platform + "/Delete",map);
    }
    
    public void logout()
    {
        mUserRightsMap.clear();
        mTreeBuilders.clear();
        mIsTop = false;
    }
    
    public boolean checkRight(String URI,String name)
    {
        if (mIsTop == true||name==null||name.equals(""))
            return true;
        else
        {
            String action = URI;
            if (action.startsWith("/XService_Workflow_Manager"))
                action = action.substring(26, action.length());
            if (action.endsWith(".do"))
                action = action.substring(0, action.length() - 3);
            if (((HashMap)mUserServerMap.get(name)).get(action) != null)
                return true;
            else
                return false;
        }
    }
    
    
	
	public void setMTreeBuilders(ArrayList treeBuilders) {
		mTreeBuilders = treeBuilders;
	}
	
	
	public ArrayList getMUserServerList() {
		return new ArrayList(mUserServerMap.keySet());
	}
	
	public String getMServerType() {
		return mServerType;
	}
}
