
package org.act.manage.conf;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class WorkflowConfigTreeBuilder    implements SubTreeBuilder
{
    
    public void buildTree(TreeControlNode treeNode, ActionServlet servlet
                          , HttpServletRequest request)
    {
        MessageResources resources = (MessageResources)
                                     servlet.getServletContext().getAttribute(
                                         Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
        TreeControlNode subTree = new TreeControlNode
                                  ("Workflow_Config",
                                   "Workflow.gif",
                                   resources.getMessage(locale
            , "wf.config.treeBuilder.config"),
                                   "treeControlAction.do?tree=Workflow_Config&select=Workflow_Config",
                                   "_self",
                                   Utils.checkTreeNodeState("Workflow_Config", false),
                                   "Workflow_Config");
        TreeControlNode types = new TreeControlNode
                                ("Workflow_Config_Runtime",
                                 "Workflow.gif",
                                 resources.getMessage(locale
            , "wf.config.treeBuilder.runtime"),
                                 "workflow/config/configEdit.do",
                                 "content",
                                 Utils.checkTreeNodeState(
            "Workflow_Config_Runtime", false),
                                 "Workflow_Config");
        treeNode.addChild(subTree);
        subTree.addChild(types); 
    }
}
