package org.act.manage.controls;
import java.io.IOException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;
import org.apache.commons.beanutils.PropertyUtils;

public class AttributeTag extends TagSupport {
        
    protected String attribute = null;
    public String getAttribute() {
        return (this.attribute);
    }
    public void setAttribute(String attribute) {
        this.attribute = attribute;
    }
    
    protected String name = null;
    public String getName() {
        return (this.name);
    }
    public void setName(String name) {
        this.name = name;
    }
    
    protected String property = null;
    public String getProperty() {
        return (this.property);
    }
    public void setProperty(String property) {
        this.property = property;
    }
    
    protected String scope = null;
    public String getScope() {
        return (this.scope);
    }
    public void setScope(String scope) {
        this.scope = scope;
    }
        
    public int doEndTag() throws JspException {
                Object bean = null;
        if (scope == null) {
            bean = pageContext.findAttribute(name);
        } else if ("page".equalsIgnoreCase(scope)) {
            bean = pageContext.getAttribute(name, PageContext.PAGE_SCOPE);
        } else if ("request".equalsIgnoreCase(scope)) {
            bean = pageContext.getAttribute(name, PageContext.REQUEST_SCOPE);
        } else if ("session".equalsIgnoreCase(scope)) {
            bean = pageContext.getAttribute(name, PageContext.SESSION_SCOPE);
        } else if ("application".equalsIgnoreCase(scope)) {
            bean = pageContext.getAttribute(name,
                                            PageContext.APPLICATION_SCOPE);
        } else {
            throw new JspException("Invalid scope value '" + scope + "'");
        }
        if (bean == null) {
            throw new JspException("No bean '" + name + "' found");
        }
        if (property != null) {
            try {
                bean = PropertyUtils.getProperty(bean, property);
            } catch (Throwable t) {
                throw new JspException
                    ("Exception retrieving property '" + property + "': " + t);
            }
            if (bean == null) {
                throw new JspException("No property '" + property + "' found");
            }
        }
               
                return (EVAL_PAGE);
    }
    
    public void release() {
        attribute = null;
        name = null;
        property = null;
        scope = null;
    }
}
