package org.act.manage.controls;
import java.util.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class PagesTag
    extends TagSupport
{
        protected String mUrl = null;
        protected String mPageVarName = "PageNum";
        protected String mTableClass = "";
        protected int mShowNumberCount = 5;
        protected int mOnePageItems = 20;
        protected int mCurrentPage = -1;
        protected String mCurrentPageName = null;
        protected int mTotalItems = -1;
        protected String mCollection = null;
    
    public void setUrl(String url)
    {
        mUrl = url;
    }
    
    public void setPageVarName(String pageVarName)
    {
        mPageVarName = pageVarName;
    }
    
    public void setTableClass(String tableClass)
    {
        mTableClass = tableClass;
    }
    
    public void setShowNumberCount(int showNumberCount)
    {
        if (showNumberCount >= 2)
            mShowNumberCount = showNumberCount;
    }
    
    public void setOnePageItems(int onePageItems)
    {
        if (onePageItems >= 5)
            mOnePageItems = onePageItems;
    }
    
    public void setCurrentPage(int currentPage)
    {
        mCurrentPage = currentPage;
    }
    
    public void setCurrentPageName(String currentPageName)
    {
        mCurrentPageName = currentPageName;
    }
    
    public void setTotalItems(int totalItems)
    {
        mTotalItems = totalItems;
    }
    
    public void setCollection(String collection)
    {
        mCollection = collection;
    }
    
    public int doEndTag() throws JspException
    {
        JspWriter out = pageContext.getOut();
        if (mOnePageItems <= 0)
            return (EVAL_PAGE);
                int cPage = getCurrentPage();
        int total = getTotal();
        if (total == 0)
            return (EVAL_PAGE);
        int totalPage = total / mOnePageItems;
        if (total % mOnePageItems != 0)
            totalPage++;
        int ch = '?';
        String url;
        if (mUrl.indexOf(ch) != -1)
            url = mUrl + "&";
        else
            url = mUrl + "?";
        try
        {
                        out.print(
                "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\""
                + mTableClass + "\">\n");
            out.print("<tr>\n");
            int tmpI = (cPage - 1) / mShowNumberCount;
            tmpI = tmpI * mShowNumberCount;
            if (cPage > mShowNumberCount)
            {
                out.print("<td width=\"20\" align=\"center\">");
                out.print("<A href=" + url + mPageVarName + "="
                          + new Integer(tmpI).toString() + "><<</A>");
                out.print("</td>\n");
            }
            out.print("<td width=\"80\" align=\"center\">&nbsp;");
            for (int i = 1; i <= mShowNumberCount; i++)
            {
                String tmpS = new Integer(tmpI + i).toString();
                if (cPage == tmpI + i)
                    out.print("<font color=#b40000>"
                              + tmpS + "&nbsp;</font>");
                if (tmpI + i <= totalPage && cPage != tmpI + i)
                    out.print("<A href=" + url + mPageVarName + "=" + tmpS
                              + ">"
                              + tmpS + "</A>" + "&nbsp;");
            }
            out.print("</td>\n");
            if (tmpI + 6 <= totalPage)
            {
                out.print("<td width=\"20\" align=\"center\">");
                out.print("<A href=" + url + mPageVarName + "="
                          + new Integer(tmpI + 6).toString() + ">>></A>");
                out.print("</td>\n");
            }
            out.print("</td>\n");
            out.print("<td width=\"90\" align=\"center\">\n");
            out.print("(");
            out.print( (cPage - 1) * (mOnePageItems) + 1);
            out.print("-");
            if (cPage * (mOnePageItems) <= total)
                out.print(cPage * (mOnePageItems));
            else
                out.print(total);
            out.print("/");
            out.print(total);
            out.print(")");
            out.print("</td>\n");
            out.print("</tr>\n");
            out.print("</table>\n");
        }
        catch (Exception e)
        {
            throw new JspException(e);
        }
        return (EVAL_PAGE);
    }
        private int getCurrentPage()
    {
        if (mCurrentPage != -1 && mCurrentPage > 0)
            return mCurrentPage;
        if (mCurrentPageName != null)
        {
            Integer ret = (Integer)pageContext.findAttribute(mCurrentPageName);
            return ret.intValue();
        }
        else
        {
            Integer ret = (Integer)pageContext.findAttribute(mPageVarName);
            if (ret != null)
                return ret.intValue();
        }
        return 1;
    }
        private int getTotal()
    {
        if (mTotalItems != -1 && mTotalItems > 0)
            return mTotalItems;
        if (mCollection != null)
        {
            Object obj = pageContext.findAttribute(mCollection);
            if (obj == null)return 0;
            if (obj instanceof Collection)
                return ( (Collection)obj).size();
            else if (obj instanceof Map)
                return ( (Map)obj).size();
            else
                return 0;
        }
        return 0;
    }
}
