package org.act.manage.controls;
import java.io.Serializable;
import java.util.ArrayList;

public class TreeControlNode implements Serializable {
    public TreeControlNode()
    {
        try
        {
            jbInit();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
     
    public TreeControlNode(String name,
                           String icon, String label,
                           String action, String target,
                           boolean expanded, String domain) {
        super();
        this.name = name;
        this.icon = icon;
        this.label = label;
        this.action = action;
        this.target = target;
        this.expanded = expanded;
        this.domain = domain;
    }
      
    protected ArrayList children = new ArrayList();
        
    protected String action = null;
    public String getAction() {
        return (this.action);
    }
    
    protected String domain = null;
    public String getDomain() {
        return (this.domain);
    }
    
    protected boolean expanded = false;
    public boolean isExpanded() {
        return (this.expanded);
    }
    public void setExpanded(boolean expanded) {
        this.expanded = expanded;
    }
    
    protected String icon = null;
    public String getIcon() {
        return (this.icon);
    }
    
    protected String label = null;
    public String getLabel() {
        return (this.label);
    }
    
    protected boolean last = false;
    public boolean isLast() {
        return (this.last);
    }
    void setLast(boolean last) {
        this.last = last;
    }
    
    public boolean isLeaf() {
        synchronized (children) {
            return (children.size() < 1);
        }
    }
    
    protected String name = null;
    public String getName() {
        return (this.name);
    }
  
    protected TreeControlNode parent = null;
    public TreeControlNode getParent() {
        return (this.parent);
    }
    void setParent(TreeControlNode parent) {
        this.parent = parent;
        if (parent == null)
            width = 1;
        else
            width = parent.getWidth() + 1;
    }
    
    protected boolean selected = false;
    public boolean isSelected() {
        return (this.selected);
    }
    public void setSelected(boolean selected) {
        this.selected = selected;
    }

    protected String target = null;
    public String getTarget() {
        return (this.target);
    }

    protected TreeControl tree = null;
    public TreeControl getTree() {
        return (this.tree);
    }
    void setTree(TreeControl tree) {
        this.tree = tree;
    }
    
    protected int width = 0;
    public int getWidth() {
        return (this.width);
    }
        
    public void addChild(TreeControlNode child)
        throws IllegalArgumentException {
        tree.addNode(child);
        child.setParent(this);
        synchronized (children) {
            int n = children.size();
            if (n > 0) {
                TreeControlNode node = (TreeControlNode) children.get(n - 1);
                node.setLast(false);
            }
            child.setLast(true);
            children.add(child);
        }
    }
    
    public void addChild(int offset, TreeControlNode child)
        throws IllegalArgumentException {
        tree.addNode(child);
        child.setParent(this);
        synchronized (children) {
            children.add(offset, child);
        }
    }
    
    public TreeControlNode[] findChildren() {
        synchronized (children) {
            TreeControlNode results[] = new TreeControlNode[children.size()];
            return ((TreeControlNode[]) children.toArray(results));
        }
    }
    
    public void remove() {
        if (tree != null) {
            tree.removeNode(this);
        }
    }
    
    public void removeChild(int offset) {
        synchronized (children) {
            TreeControlNode child =
                (TreeControlNode) children.get(offset);
            tree.removeNode(child);
            child.setParent(null);
            children.remove(offset);
        }
    }
        
    void removeChild(TreeControlNode child) {
        if (child == null) {
            return;
        }
        synchronized (children) {
            int n = children.size();
            for (int i = 0; i < n; i++) {
                if (child == (TreeControlNode) children.get(i)) {
                    children.remove(i);
                    return;
                }
            }
        }
    }
    private void jbInit() throws Exception
    {
    }
}
