
package org.act.manage.objectPool;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.namespace.QName;
import org.act.manage.util.CallServer;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ObjectPoolInfoAction extends Action {
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		
		String name = (String) request.getParameter("Name");
		HttpSession session = request.getSession();
		session.setAttribute("ObjectPoolName",name);
		String backPage = (String) session.getAttribute("Util_SucBackUrl");
		String serverType = (String) request.getSession().getAttribute(
				"ServerType");
		String server = (String) request.getSession().getAttribute("Server");
		String ObjectPoolSize_in = "";
		String ObjectPoolSize_out = "";
		String ObjectPoolMaxSize_in = "";
		String ObjectPoolMaxSize_out = "";
		
		String uri=ServerInfo.getServerAddress(server, serverType).getAddress();
		if (serverType.equals("WSRuntime"))
		{
			try{
				ObjectPoolSize_in = (String) CallServer.invoke(
						"getObjectPoolSize", uri, TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "in" });
				ObjectPoolSize_out = (String) CallServer.invoke("getObjectPoolSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "out" });
				ObjectPoolMaxSize_in = (String) CallServer.invoke("getObjectPoolMaxSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "in" });
				ObjectPoolMaxSize_out = (String) CallServer.invoke("getObjectPoolMaxSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
							javax.xml.rpc.encoding.XMLType.XSD_STRING,
							javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "out" });
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		else if (serverType.equals("WorkflowEngine")) {
			try {
				ObjectPoolSize_in = (String) CallWfEngine.invoke(
						"getObjectPoolSize", uri, TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "in" });
				ObjectPoolSize_out = (String) CallWfEngine.invoke("getObjectPoolSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "out" });
				ObjectPoolMaxSize_in = (String) CallWfEngine.invoke("getObjectPoolMaxSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
								javax.xml.rpc.encoding.XMLType.XSD_STRING,
								javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "in" });
				ObjectPoolMaxSize_out = (String) CallWfEngine.invoke("getObjectPoolMaxSize", uri,
						TMConstants.XSD_STRING,
						new QName[] {
							javax.xml.rpc.encoding.XMLType.XSD_STRING,
							javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name, "out" });
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		else
		{
			return mapping.findForward("Fail");
		}
		request.setAttribute("Name", name);
		request.setAttribute("ObjectPoolSize_in", ObjectPoolSize_in);
		request.setAttribute("ObjectPoolSize_out", ObjectPoolSize_out);
		request.setAttribute("ObjectPoolMaxSize_in", ObjectPoolMaxSize_in);
		request.setAttribute("ObjectPoolMaxSize_out", ObjectPoolMaxSize_out);
		return mapping.findForward("Forward");
	}
}
