
package org.act.manage.threadpool;
import java.util.Locale;
import javax.servlet.http.HttpSession;
import javax.servlet.http.*;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.act.manage.controls.*;
import org.act.manage.util.Utils;

public class ThreadpoolTreeBuilder implements SubTreeBuilder{
	public ThreadpoolTreeBuilder() {
        try {
            jbInit();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
  
    public void buildTree(TreeControlNode treeNode,
                          ActionServlet servlet,
                          HttpServletRequest request) {
        MessageResources resources = (MessageResources)
            servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
        try {
            addSubtree(treeNode, resources, locale);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
        
    protected void addSubtree(TreeControlNode root,
                              MessageResources resources,
                              Locale locale)
        throws Exception {
        
                TreeControlNode subtree = new TreeControlNode
            ("ThreadpoolInfo",
             "XLinker.gif",
             resources.getMessage(locale,
					"tree.ThreadPoolInfo"),
             "threadpool/ThreadPoolList.do",
             "content",
             Utils.checkTreeNodeState("ThreadpoolInfo",false),
             "Services");
        root.addChild(subtree);
        
    }
    private void jbInit() throws Exception {
    }
}
