/*
 * Created on 2005-7-28
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.manage.transaction;

import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;


public class TransactionTreeBuilder  implements SubTreeBuilder{
	public TransactionTreeBuilder() {
        try {
            jbInit();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Add the required nodes to the specified <code>treeControl</code>
     * instance.
     *
     * @param treeControl The <code>TreeControl</code> to which we should
     *  add our nodes
     * @param servlet The controller servlet for the admin application
     * @param request The servlet request we are processing
     */
    public void buildTree(TreeControlNode treeNode,
                          ActionServlet servlet,
                          HttpServletRequest request) {

        MessageResources resources = (MessageResources)
            servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
        try {
            addSubtree(treeNode, resources, locale);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }


    // ------------------------------------------------------ Protected Methods


    /**
     * Add the subtree of nodes required for user administration.
     *
     * @param root The root node of our tree control
     * @param resources The MessageResources for our localized messages
     *  messages
     */
    protected void addSubtree(TreeControlNode root,
                              MessageResources resources,
                              Locale locale)
        throws Exception {

        TreeControlNode subtree = new TreeControlNode
            ("WSRuntime_TransactionInfo",
             "XLinker.gif",
             resources.getMessage(locale,
				"transaction.treebuider.transactionInfoNode"),
             "treeControlAction.do?tree=WSRuntime_TransactionInfo&select=WSRuntime_TransactionInfo",
             "_self",
             Utils.checkTreeNodeState("WSRuntime_TransactionInfo",false),
             "WSRuntime_TransactionInfo");
        TreeControlNode transactionList = new TreeControlNode
	        ("WSRuntime_TransactionList",
	         "XLinker.gif",
	         resources.getMessage(locale,
	         "transaction.treebuider.transactionListNode"),
	         "wsruntime/transaction/transactionList.do",
	         "content",
	         Utils.checkTreeNodeState("WSRuntime_TransactionList",false),
	         "WSRuntime_TransactionInfo");
        
        root.addChild(subtree);
        subtree.addChild(transactionList);
        
    }

    private void jbInit() throws Exception {
    }
}
