
package org.act.manage.user;
import java.util.Locale;
import javax.servlet.http.HttpSession;
import javax.servlet.http.*;
import org.act.manage.controls.*;
import org.act.manage.util.Utils;
import org.apache.struts.action.*;
import org.apache.struts.util.MessageResources;
import org.apache.struts.Globals;

public class UserTreeBuilder implements TreeBuilder {
	
	public void buildTree(TreeControl treeControl, ActionServlet servlet,
			HttpServletRequest request) {
		MessageResources resources = (MessageResources) servlet
				.getServletContext().getAttribute(Globals.MESSAGES_KEY);
		HttpSession session = request.getSession();
		Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
		TreeControlNode userNode = new TreeControlNode(
				"User",
				"User.gif",
				resources.getMessage(locale, "user.treebuilder.usermanagement"),
				"treeControlAction.do?tree=User&select=User", "_self", Utils
						.checkTreeNodeState("User", false), "User");
		treeControl.getRoot().addChild(userNode);
		TreeControlNode subTree = new TreeControlNode("User_add", "User.gif",
				resources.getMessage(locale, "user.treebuilder.useradd"),
								"user/configEdit.do",
								"content", Utils.checkTreeNodeState("User_add", false),
				"User_add");
		userNode.addChild(subTree);
		subTree = new TreeControlNode("User_list", "User.gif", resources
				.getMessage(locale, "user.treebuilder.list"),
				"user/userList.do",
								"content", Utils.checkTreeNodeState("User_list", false),
				"User_list");
		userNode.addChild(subTree);
		subTree = new TreeControlNode("Server_add", "User.gif", resources
				.getMessage(locale, "util.error.more"), 
								"user/serverConfigEdit.do",
						"content", Utils.checkTreeNodeState("Server_add", false),
				"Server_add");
		userNode.addChild(subTree);
	}
}
