
package org.act.manage.workflow.db;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Vector;
import org.act.manage.util.ConnectionDB;

public class ProcessInfo {
    
    public static HashMap queryNumberInfo(Connection connection){
        HashMap typeNumber = new HashMap();
        String sqlQuery = "select Type, count(ID) from bpelinstance"+
            " group by Type";
        try {
        	            Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            while (resultset.next()){
                typeNumber.put(resultset.getObject(1), resultset.getObject(2));
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
        return typeNumber;
    }
    
    public static Vector queryTypeInfo(Connection connection,String type){
        Vector typeInfo = new Vector();
        String sqlQuery = "select * from bpelinstance where Type = '"+
            type +"' order by ID desc";
        try {
        	            Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            ResultSetMetaData metadata = resultset.getMetaData();
            while (resultset.next()) {
                Vector oneInfo = new Vector();
                for (int i = 2; i <= metadata.getColumnCount(); i++)
                    oneInfo.addElement(resultset.getObject(i));
                typeInfo.addElement(oneInfo);
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
        return typeInfo;
    }
    
    public static Vector queryInfo(String instanceID){
        Vector processInfo = new Vector();
        String sqlQuery = "select * from bpelinstance where "+
            "InstanceID = '"+ instanceID +"'";
        try {
        	Connection connection = new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            ResultSetMetaData metadata = resultset.getMetaData();
            while (resultset.next()) {
                for (int i = 3; i <= metadata.getColumnCount(); i++)
                    processInfo.addElement(resultset.getObject(i));
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
        return processInfo;
    }
    
    public boolean insert(int ownerID, String instanceID, String type,
                          String startTime, String finishTime, String status,
                          String isShutdown){
        String sqlInsert = "insert into bpelinstance" +
            "(OwnerID,InstanceID,Type,StartTime,FinishTime,Status,IsShutdown) values("+
            ownerID +",'"+ instanceID +"','"+ type +"','"+ startTime +"','"+
            finishTime +"','"+ status +"','"+ isShutdown +"')";
        try{
            Connection connection = new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            statement.executeUpdate(sqlInsert);
            statement.close();
            connection.close();
            return true;
        }
        catch(SQLException ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }
    
    public boolean update(String instanceID, String fieldName, String fieldValue){
        String sqlUpdate = "update bpelinstance set "+
            fieldName +" = '"+ fieldValue +"' where InstanceID = '"+ instanceID +"'";
        try{
            Connection connection = new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            statement.executeUpdate(sqlUpdate);
            statement.close();
            connection.close();
            return true;
        }
        catch(SQLException ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }
    
    public boolean updateInit(int ownerID, String fieldName, String fieldValue){
        String sqlUpdate = "update bpelinstance set "+
            fieldName +" = '"+ fieldValue +"' where OwnerID = "+ ownerID +"";
        try{
            Connection connection = new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            statement.executeUpdate(sqlUpdate);
            statement.close();
            connection.close();
            return true;
        }
        catch(SQLException ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }
    
    public static HashMap queryLogInfoGroupbyType(Connection connection,String startTime, String finishTime,
                                           String fieldName){
                HashMap map = new HashMap();
                if (startTime.compareTo(finishTime) > 0)
            return map;
        String sqlQuery = "select Type, count(ID) from bpelinstance where "+
            fieldName +" between '"+ startTime+"' and '"+ finishTime
            +"' group by Type";
        try {
                        Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            while (resultset.next()){
                map.put(resultset.getObject(1), resultset.getObject(2));
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
                return map;
    }
    
    public static Vector queryLogInfo(Connection connection,String startTime, String finishTime,
                                String interval, String fieldName, String type){
                Vector vector = new Vector();
                Date startDate = new Date();
        Date finishDate = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat();
        sdf.applyPattern("yyyy-MM-dd HH:mm:ss");
        try{
            startDate = sdf.parse(startTime);
            finishDate = sdf.parse(finishTime);
        }
        catch(ParseException e){
            System.err.println(e.getMessage());
            return vector;
        }
                if (startDate.after(finishDate))
            return vector;
                Date tempDate = startDate;
        String tempString = "";
                if (interval.equals("year")){
            sdf.applyPattern("yyyy");
            while (tempDate.before(finishDate)){
                tempString = sdf.format(tempDate).toString();
                                Vector vectoryear = new Vector();
                vectoryear.addElement(tempString);
                vectoryear.addElement(Integer.toString(queryLogNumber(connection,tempString,fieldName,type)));
                vector.addElement(vectoryear);
                tempDate.setMonth(0);
                tempDate.setDate(1);
                tempDate.setHours(0);
                tempDate.setMinutes(0);
                tempDate.setSeconds(0);
                tempDate.setYear(tempDate.getYear() + 1);
            }
        }
                else if (interval.equals("month")){
            sdf.applyPattern("yyyy-MM");
            while (tempDate.before(finishDate)){
                tempString = sdf.format(tempDate).toString();
                                Vector vectormonth = new Vector();
                vectormonth.addElement(tempString);
                vectormonth.addElement(Integer.toString(queryLogNumber(connection,tempString,fieldName,type)));
                vector.addElement(vectormonth);
                tempDate.setDate(1);
                tempDate.setHours(0);
                tempDate.setMinutes(0);
                tempDate.setSeconds(0);
                tempDate.setMonth(tempDate.getMonth() + 1);
            }
        }
                else if (interval.equals("date")){
            sdf.applyPattern("yyyy-MM-dd");
            while (tempDate.before(finishDate)){
                tempString = sdf.format(tempDate).toString();
                                Vector vectordate = new Vector();
                vectordate.addElement(tempString);
                vectordate.addElement(Integer.toString(queryLogNumber(connection,tempString,fieldName,type)));
                vector.addElement(vectordate);
                tempDate.setHours(0);
                tempDate.setMinutes(0);
                tempDate.setSeconds(0);
                tempDate.setDate(tempDate.getDate() + 1);
            }
        }
                return vector;
    }
    
    private static int queryLogNumber(Connection connection,String tempString, String fieldName, String type){
                int number = 0;
        String sqlQuery;
                if (type == null || type.equals("")){
            sqlQuery = "select count(ID) from bpelinstance where " + fieldName +
                " like '" + tempString + "%'";
        }
                else{
            sqlQuery = "select count(ID) from bpelinstance where " + fieldName +
                " like '" + tempString + "%' and Type = '"+ type +"'";
        }
        try {
                        Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            if (resultset.next()){
                number = Integer.parseInt(resultset.getObject(1).toString());
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.err.println(ex.getMessage());
        }
                return number;
    }
    
    public static boolean delete(Connection connection,String instanceID) {
        String sqlDelete = "delete from bpelinstance where " +
            "InstanceID = '" + instanceID + "'";
        try {
                        Statement statement = connection.createStatement();
            statement.executeUpdate(sqlDelete);
            statement.close();
            connection.close();
            return true;
        }
        catch (SQLException ex) {
            return false;
        }
    }
    public static void main(String[] args) {
                Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(date).toString();
                        
                
        
                
           }
}
