package org.act.manage.workflow.instance;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ConnectionDB;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.workflow.WorkflowException;
import org.act.manage.workflow.db.ActivityInfo;
import org.act.manage.workflow.meta.ActivityInfoMeta;
import org.act.manage.workflow.process.GenerateSvg;
import org.act.wsc.bpel4wsmodeling.bpeldata.BPELProcess;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ActivityGraphAction
    extends Action
{
    private boolean needUpdateTree = false;
    public ActionForward execute(ActionMapping
                                 mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws
        ServletException
    {
    	
    	
    	BPELProcess bp;
    	String BPELFilePath = "d:/test.bpel";
    	String SvgFilePath = "d:/test.svg";
    	String pro = "";
    	try{
    		
    		ArrayList al = new ArrayList();
    		Vector processes;
            String type = (String)request.getSession().getAttribute(
                "WF_History_Type");
            pro = request.getParameter("ID");
            String serverType=(String)request.getSession().getAttribute("ServerType");
    		String server=(String)request.getSession().getAttribute("Server");
            CallWfEngine callServer=new CallWfEngine
    		(ServerInfo.getServerAddress(server,serverType).getAddress());
                        String actis=callServer.getActivity(pro);
            String activity[]=actis.split("`");
            
            for (int j=0;j<activity.length/6;j++)
            {
            	ActivityInfoMeta act=new ActivityInfoMeta();
            	act.setName(activity[j*6+0]);
            	act.setType(activity[j*6+1]);
            	act.setBeginTime(activity[j*6+2]);
            	if(activity[j*0+3].equalsIgnoreCase("null"))
            		act.setEndTime("");
            	else
            		act.setEndTime(activity[j*6+3]);
            	act.setStatus(activity[j*6+4]);
            	if(activity[j*6+5]!=null&&!activity[j*6+5].equals("null"))
            		act.setTxID(activity[j*6+5]);
            	al.add(act);
            	
            }
           
            GenerateSvg gs=new GenerateSvg();
            String fileName=gs.GenerateProSvg(ServerInfo.getServerAddress(server,serverType).getAddress(),type,al);
            request.getSession().setAttribute("WF_Activity_Graph", fileName);
            request.getSession().setAttribute("GHeight", String.valueOf(gs.getGHeight()));
            request.getSession().setAttribute("GWidth",  String.valueOf(gs.getGWidth()));
            setHistorySession(request, pro, type);
        }
        catch (Exception ex)
        {
                        request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
            String tmp = AdminResBundle.getMessage(
                "wf.process.error.actGrphList",pro);
            tmp += " " + ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        if (needUpdateTree)
        {
            needUpdateTree = false;
            request.getSession().setAttribute("Util_AfterUpdateTree",
                                              "/workflow/instance/processActivityGraph.jsp");
            return mapping.findForward("UpdateTree");
        }
        else
        {
            return mapping.findForward("Forward");
        }
    }
        private void setHistorySession(HttpServletRequest request, String ID
                                   , String type) throws Exception
    {
    	String hisID = (String)request.getSession().getAttribute(
        "WF_History_Process");
    if (hisID == null || !hisID.equals(ID))
    {
        request.getSession().setAttribute("WF_History_Process", ID);
        request.getSession().setAttribute("WF_History_TransactionID", null);
        
        needUpdateTree = true;
    }
}
}
