package org.act.manage.workflow.process;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ConnectionDB;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.workflow.WorkflowException;
import org.act.manage.workflow.meta.ActivityInfoMeta;
import org.act.manage.workflow.db.ActivityInfo;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ActivityListAction
    extends Action
{
    private boolean needUpdateTree = false;
    public ActionForward execute(ActionMapping
                                 mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws
        ServletException
    {
        String pro = "";
        try
        {
            
            
            ArrayList al = new ArrayList();
            String type = (String)request.getSession().getAttribute(
                "WF_History_Type");
            pro = request.getParameter("ID");
                        Vector processes;
            String serverType = (String) request.getSession().getAttribute(
			"ServerType");
            String server = (String) request.getSession().getAttribute("Server");
            ServerInfoMeta serverMeta=ServerInfo.getServerAddress(server,serverType);
            Connection connection = new 
				ConnectionDB().getConnection(serverMeta.getDBaddress(),
						serverMeta.getDBUser(),serverMeta.getDBPWD());
            processes=ActivityInfo.queryActivityInfo(connection,pro);
            connection.close();
                        if (processes == null)
                throw new WorkflowException(AdminResBundle.getMessage(
                    "util.error.nullRes", "Activity Process ID"));
                        Vector oneInfo;
            for (int i = 0; i < processes.size(); i++)
            {
                oneInfo = (Vector)processes.get(i);
                ActivityInfoMeta info = new ActivityInfoMeta();
                info.setName(oneInfo.get(0).toString());
                info.setBeginTime(oneInfo.get(2).toString());
                info.setEndTime(oneInfo.get(3).toString());
                info.setType(oneInfo.get(1).toString());
                info.setStatus(makeStatusString(oneInfo));
                if (oneInfo.get(5)!= null)
                {
					info.setTxID(oneInfo.get(5).toString());																			}
				al.add(info);
			}
                        request.getSession().setAttribute("WF_ActivityList", al);
            setHistorySession(request, pro, type);
        }
        catch (Exception ex)
        {
                        request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
            String tmp = AdminResBundle.getMessage("wf.process.error.actList"
                , pro);
            tmp += " " + ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        if (needUpdateTree)
        {
            needUpdateTree = false;
            request.getSession().setAttribute("Util_AfterUpdateTree",
                                              "/workflow/process/processActivity.jsp");
            return mapping.findForward("UpdateTree");
        }
        else
            return mapping.findForward("Forward");
    }
        private void setHistorySession(HttpServletRequest request, String ID
                                   , String type) throws Exception
    {
        String hisID = (String)request.getSession().getAttribute(
            "WF_History_Process");
        if (hisID == null || !hisID.equals(ID))
        {
            request.getSession().setAttribute("WF_History_Process", ID);
            
                        request.getSession().setAttribute("WF_History_TransactionID", null);
                        needUpdateTree = true;
        }
    }
        private String makeStatusString(Vector oneInfo)
    {
        String status = oneInfo.elementAt(4).toString();
        if (status.equalsIgnoreCase("created"))
            return AdminResBundle.getMessage("wf.process.table.status.created");
        else if (status.equalsIgnoreCase("enabled"))
            return AdminResBundle.getMessage("wf.process.table.status.enabled");
        else if (status.equalsIgnoreCase("disabled"))
            return AdminResBundle.getMessage("wf.process.table.status.disabled");
        else if (status.equalsIgnoreCase("completed"))
            return AdminResBundle.getMessage(
                "wf.process.table.status.completed");
        else if (status.equalsIgnoreCase("running"))
            return AdminResBundle.getMessage("wf.process.table.status.running");
        else if (status.equalsIgnoreCase("activate"))
            return AdminResBundle.getMessage("wf.process.table.status.activate");
        else
            return " ";
    }
}
