
package org.act.manage.workflow.process;
import java.util.Locale;
import javax.servlet.http.*;
import org.act.manage.controls.*;
import org.act.manage.util.*;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import javax.servlet.http.HttpSession;

public class ProcessTreeBuilder     implements SubTreeBuilder
{
	  
	  public void buildTree(TreeControlNode treeNode, ActionServlet servlet
	                        , HttpServletRequest request)
	  {
	    MessageResources resources = (MessageResources)
	                                 servlet.getServletContext().getAttribute(
	        Globals.MESSAGES_KEY);
	    HttpSession session = request.getSession();
	    Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
	    TreeControlNode subTree = new TreeControlNode
	                              ("Workflow_Process",
	                               "Workflow.gif",
	                               resources.getMessage(locale
	        , "wf.process.treeBuilder.process"),
	                               "treeControlAction.do?tree=Workflow_Process&select=Workflow_Process",
	                               "_self",
	                               Utils.checkTreeNodeState("Workflow_Process", false),
	                               "Workflow_Process");
	    TreeControlNode types = new TreeControlNode
	                            ("Workflow_Process_Types",
	                             "Workflow.gif",
	                             resources.getMessage(locale
	                                                  ,
	        "wf.process.treeBuilder.types"),
	        "workflow/process/processTypesList.do",
	        "content",
	                             Utils.checkTreeNodeState(
	        "Workflow_Process_Types", false),
	                             "Workflow_Process");
	    treeNode.addChild(subTree);
	    subTree.addChild(types);
	    	    String type = (String)request.getSession().getAttribute(
	        "WF_History_Type");
	    String proID = (String)request.getSession().getAttribute(
	        "WF_History_Process");
	    String busID = (String)request.getSession().getAttribute(
	        "WF_History_Business");
	    String txID = (String)request.getSession().getAttribute(
	        "WF_History_TransactionID");
	    String tmpUrl = null;
	    if (type != null)
	    {
	      tmpUrl = "workflow/process/processList.do?Type=" + type;
	      TreeControlNode processes = new TreeControlNode
	                                  ("Workflow_Process_Processes",
	                                   "Workflow.gif",
	                                   resources.getMessage(locale
	          , "wf.process.title.process"),
	                                   tmpUrl,
	                                   "content",
	                                   Utils.checkTreeNodeState(
	          "Workflow_Process_Processes", false),
	                                   "Workflow_Process");
	      subTree.addChild(processes);
	    }
	    if (proID != null)
	    {
	      tmpUrl = "workflow/process/activityList.do?ID=" + proID;
	      TreeControlNode activity = new TreeControlNode
	                                 ("Workflow_Process_Activity",
	                                  "Workflow.gif",
	                                  resources.getMessage(locale
	          , "wf.process.title.activity"),
	                                  tmpUrl,
	                                  "content",
	                                  Utils.checkTreeNodeState(
	          "Workflow_Process_Activity", false),
	                                  "Workflow_Process");
	      subTree.addChild(activity);
	      tmpUrl = "workflow/process/activityGraph.do?ID=" + proID;
	      TreeControlNode activityG = new TreeControlNode
	                                  ("Workflow_Process_ActivityG",
	                                   "Workflow.gif",
	                                   resources.getMessage(locale
	          , "wf.process.title.activityG"),
	                                   tmpUrl,
	                                   "content",
	                                   Utils.checkTreeNodeState(
	          "Workflow_Process_ActivityG", false),
	                                   "Workflow_Process");
	      subTree.addChild(activityG);
	    }
	    if (txID != null)
	    {
	      String tmpTxID=transferUrl(txID);
	      tmpUrl = "workflow/process/transactionInfo.do?txID=" + tmpTxID;
	      TreeControlNode transaction = new TreeControlNode
	                                    ("Workflow_Process_Transaction",
	                                     "Workflow.gif",
	                                     resources.getMessage(locale
	          , "wf.process.title.transaction"),
	                                     tmpUrl,
	                                     "content",
	                                     Utils.checkTreeNodeState(
	          "Workflow_Process_Transaction", false),
	                                     "Workflow_Process");
	      subTree.addChild(transaction);
	     }
	  }
	  
	  private static String transferUrl(String s)
	  {
	    StringBuffer str = new StringBuffer();
	    int len = (s != null) ? s.length() : 0;
	    for (int i = 0; i < len; i++)
	    {
	      char ch = s.charAt(i);
	      switch (ch)
	      {
	        case '[':
	        {
	          str.append("%5B");
	          break;
	        }
	        case ']':
	        {
	          str.append("%5D");
	          break;
	        }
	        case '/':
	        {
	          str.append("%2F");
	          break;
	        }
	        case ':':
	        {
	          str.append("%3A");
	          break;
	        }
	        default:
	        {
	          str.append(ch);
	        }
	      }
	    }
	    return (str.toString());
	  }
	}
