
package org.act.manage.wsruntime;
import java.util.Locale;
import javax.servlet.http.*;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.act.manage.controls.*;
import org.act.manage.util.CallServer;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.Utils;

public class ServicesTreeBuilder implements SubTreeBuilder {
	public ServicesTreeBuilder() {
		try {
			jbInit();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	public void buildTree(TreeControlNode treeNode, ActionServlet servlet,
			HttpServletRequest request) {
		MessageResources resources = (MessageResources) servlet
				.getServletContext().getAttribute(Globals.MESSAGES_KEY);
		HttpSession session = request.getSession();
		Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
		try {
			addSubtree(treeNode, resources, locale, request);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
		
	protected void addSubtree(TreeControlNode root, MessageResources resources,
			Locale locale, HttpServletRequest request) throws Exception {
				TreeControlNode subtree = new TreeControlNode("Services",
				"XLinker.gif", resources.getMessage(locale,
						"services.treeBuilder.subtreeNode"),
				"wsruntime/service/listServices.do", "content", Utils
						.checkTreeNodeState("Services", false), "Services");
		root.addChild(subtree);
		String serverType=(String)request.getSession().getAttribute("ServerType");
		String server=(String)request.getSession().getAttribute("Server");
		CallServer callServer = new CallServer(
				ServerInfo.getServerAddress(server,serverType).getAddress());
		String result = "";
		try {
			result = callServer.testListServices();
		} catch (Exception e) {
			e.printStackTrace();
		}
		String serviceNames[] = result.split("#");
		for (int i = 1; i < serviceNames.length; i++) {
			String serviceName = serviceNames[i];
			TreeControlNode serviceNode = new TreeControlNode(serviceName,
					"XLinker.gif", serviceName,
					"wsruntime/service/showServiceDetail.do?service="
							+ serviceName, "content", Utils.checkTreeNodeState(
							serviceName, false), "Services");
			subtree.addChild(serviceNode);
		}
		TreeControlNode serviceNode = new TreeControlNode("DeployService",
				"XLinker.gif", resources.getMessage(locale,
						"engine.treeBuilder.deploynewNode"),
				"wsruntime/deploy/upload.do", "content", Utils
						.checkTreeNodeState("DeployService", false), "Services");
		subtree.addChild(serviceNode);
	}
	private void jbInit() throws Exception {
	}
}
