
package org.act.manage.wsruntime;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.conf.ConfigTreeBuilder;
import org.act.manage.controls.SubTreeBuilder;
import org.act.manage.controls.TreeBuilder;
import org.act.manage.controls.TreeControl;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.jvm.JVMTreeBuilder;
import org.act.manage.log.LogInfoTreeBuilder;
import org.act.manage.objectPool.ObjectPoolTreeBuilder;
import org.act.manage.soap.SOAPTreeBuilder;
import org.act.manage.threadpool.ThreadpoolTreeBuilder;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class WSRuntimeTreeBuilder 
implements TreeBuilder
{
    
    public void buildTree(TreeControl treeControl, ActionServlet servlet
                          , HttpServletRequest request)
    {
        MessageResources resources = (MessageResources)servlet.
                                     getServletContext().getAttribute(Globals.
            MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
        TreeControlNode WSRuntimeNode = new TreeControlNode
                                      ("ACTSoap",
                                       "XLinker.gif",
                                       resources.getMessage(locale
            , "xlinker.treeControl.ACTXlinker"),
                                       "treeControlAction.do?tree=ACTSoap&select=ACTSoap",
                                       "_self",
                                       Utils.checkTreeNodeState("ACTSoap",true),
                                       "ACTSoap");
        treeControl.getRoot().addChild(WSRuntimeNode);
        SubTreeBuilder builder = new ServicesTreeBuilder();
        builder.buildTree(WSRuntimeNode, servlet, request);
        
        builder = new JVMTreeBuilder();
        builder.buildTree(WSRuntimeNode,servlet,request);
        builder = new ThreadpoolTreeBuilder();
        builder.buildTree(WSRuntimeNode,servlet,request);
        builder = new ObjectPoolTreeBuilder();
        builder.buildTree(WSRuntimeNode,servlet,request);
        builder = new SOAPTreeBuilder();
        builder.buildTree(WSRuntimeNode,servlet,request);
        builder = new ConfigTreeBuilder();
        builder.buildTree(WSRuntimeNode,servlet,request);
    }
}
